---
product: "AG Grid"
title: "Row Dragging Between Grids"
description: "Row Drag Between Grids is concerned with seamless integration among different grids, allowing records to be dragged from one grid and dropped at a specific index on another grid."
framework: javascript
version: "36.2.0"
related:
    - title: "Managed Row Dragging"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-dragging-managed/"
    - title: "Unmanaged Row Dragging"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-dragging-unmanaged/"
    - title: "Row Dragging Customisation"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-dragging-customisation/"
    - title: "External DropZone"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-dragging-to-external-dropzone/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Row Dragging Between Grids

Row Drag Between Grids is concerned with seamless integration among different grids, allowing records to be dragged from one grid and dropped at a specific index on another grid.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `addRowDropZone` | `Function` |  |  |  |
| `removeRowDropZone` | `Function` |  |  |  |
| `getRowDropZoneParams` | `Function` |  |  |  |

## Adding a Grid as Target

To allow adding a grid as DropZone, the `getRowDropZoneParams` API method should be used in the target grid and the `addRowDropZone` in the source grid.

```js
const dropZoneParams = targetGridApi.getRowDropZoneParams({
    onDragStop: function() {
        alert('Record Dropped!');
    }
});

if (dropZoneParams) {
    sourceGridApi.addRowDropZone(dropZoneParams);

    // when the DropZone above is no longer needed
    sourceGridApi.removeRowDropZone(dropZoneParams);
}
```

In the example below, note the following:

- When you drag from one grid to another, a line will appear indicating where the row will be placed.
- Rows can be dragged from one grid to the other grid. When the row is received, it is **not** removed from the first grid. This is the choice of the example. The example could equally have removed from the other grid.
- Rows can be removed from both grids by dragging the row to the 'Trash' drop zone.
- New rows can be created by clicking on the red, green and blue buttons.

#### Two Grids with Drop Position

```ts
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowApiModule,
  RowDragModule,
  RowDropZoneParams,
  RowStyleModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

// Register the required feature modules with the Grid
if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelApiModule,
  RowApiModule,
  TextFilterModule,
  RowDragModule,
  RowStyleModule,
  ClientSideRowModelModule,
]);

let rowIdSequence = 100;

const leftColumnDefs: ColDef[] = [
  { field: "id", rowDrag: true },
  { field: "color" },
  { field: "value1" },
  { field: "value2" },
];

const rightColumnDefs: ColDef[] = [
  { field: "id", rowDrag: true },
  { field: "color" },
  { field: "value1" },
  { field: "value2" },
];
let leftApi: GridApi;
const leftGridOptions: GridOptions = {
  defaultColDef: {
    flex: 1,
    minWidth: 100,
    filter: true,
  },
  rowClassRules: {
    "red-row": 'data.color == "Red"',
    "green-row": 'data.color == "Green"',
    "blue-row": 'data.color == "Blue"',
  },
  getRowId: (params: GetRowIdParams) => {
    return String(params.data.id);
  },
  rowData: createRowBlock(2),
  rowDragManaged: true,
  suppressMoveWhenRowDragging: true,
  columnDefs: leftColumnDefs,
  onGridReady: (params) => {
    addBinZone(params);
    addGridDropZone(params, "Right");
  },
};
let rightApi: GridApi;
const rightGridOptions: GridOptions = {
  defaultColDef: {
    flex: 1,
    minWidth: 100,
    filter: true,
  },
  rowClassRules: {
    "red-row": 'data.color == "Red"',
    "green-row": 'data.color == "Green"',
    "blue-row": 'data.color == "Blue"',
  },
  getRowId: (params: GetRowIdParams) => {
    return String(params.data.id);
  },
  rowData: createRowBlock(2),
  rowDragManaged: true,
  suppressMoveWhenRowDragging: true,
  columnDefs: rightColumnDefs,
  onGridReady: (params) => {
    addBinZone(params);
    addGridDropZone(params, "Left");
  },
};

function createRowBlock(blocks: number) {
  blocks = blocks || 1;

  let output: any[] = [];

  for (let i = 0; i < blocks; i++) {
    output = output.concat(
      ["Red", "Green", "Blue"].map(function (color) {
        return createDataItem(color);
      }),
    );
  }

  return output;
}

function createDataItem(color: string) {
  return {
    id: rowIdSequence++,
    color: color,
    value1: Math.floor(window.agRandom() * 100),
    value2: Math.floor(window.agRandom() * 100),
  };
}

function addRecordToGrid(side: string, data: any) {
  // if data missing or data has no it, do nothing
  if (!data || data.id == null) {
    return;
  }

  let api = side === "left" ? leftApi : rightApi,
    // do nothing if row is already in the grid, otherwise we would have duplicates
    rowAlreadyInGrid = !!api!.getRowNode(data.id),
    transaction;

  if (rowAlreadyInGrid) {
    console.log("not adding row to avoid duplicates in the grid");
    return;
  }

  transaction = {
    add: [data],
  };

  api!.applyTransaction(transaction);
}

function onFactoryButtonClick(e: any) {
  const button = e.currentTarget,
    buttonColor = button.getAttribute("data-color"),
    side = button.getAttribute("data-side"),
    data = createDataItem(buttonColor);

  addRecordToGrid(side, data);
}

function binDrop(data: any) {
  // if data missing or data has no id, do nothing
  if (!data || data.id == null) {
    return;
  }

  const transaction = {
    remove: [data],
  };

  [leftApi, rightApi].forEach((api) => {
    const rowsInGrid = !!api!.getRowNode(data.id);

    if (rowsInGrid) {
      api!.applyTransaction(transaction);
    }
  });
}

function addBinZone(params: GridReadyEvent) {
  const eBin = document.querySelector(".bin") as any,
    icon = eBin.querySelector("i"),
    dropZone: RowDropZoneParams = {
      getContainer: () => {
        return eBin;
      },
      onDragEnter: () => {
        eBin.style.color = "blue";
        icon.style.transform = "scale(1.5)";
      },
      onDragLeave: () => {
        eBin.style = "";
        icon.style.transform = "scale(1)";
      },
      onDragStop: (params) => {
        binDrop(params.node.data);
        eBin.style = "";
        icon.style.transform = "scale(1)";
      },
    };

  params.api.addRowDropZone(dropZone);
}

function addGridDropZone(params: GridReadyEvent, side: string) {
  const api = (side === "Left" ? leftApi : rightApi)!;
  const dropZone = api.getRowDropZoneParams();

  params.api.addRowDropZone(dropZone);
}

function loadGrid(side: string) {
  const grid = document.querySelector<HTMLElement>("#e" + side + "Grid")!;
  if (side === "Left") {
    leftApi = createGrid(grid, leftGridOptions);
  } else {
    rightApi = createGrid(grid, rightGridOptions);
  }
}

const buttons = document.querySelectorAll("button.factory");

for (let i = 0; i < buttons.length; i++) {
  buttons[i].addEventListener("click", onFactoryButtonClick);
}

loadGrid("Left");
loadGrid("Right");
```

[Live example: Two Grids with Drop Position](https://www.ag-grid.com/archive/36.2.0/examples/row-dragging-to-grid/two-grids-with-drop-position/typescript/)

## Dragging Multiple Records Between Grids

It is possible to drag multiple records at once from one grid to another.

In the example below, note the following:

- This example enables [Multi-Row Dragging](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-dragging-managed/#multi-row-dragging) between grids using `rowDragMultiRow`.
- When `Remove Source Rows` is selected, the rows will be removed from the **Athletes** grid once they are dropped onto the **Selected Athletes** grid.
- If `Only Deselect Source Rows` is selected, all selected rows that were copied will be deselected but will not be removed.
   Note: If some rows are selected and a row that isn't selected is copied, the selected rows will remain selected.
- If `None` is selected, the rows will be copied from one grid to another and the source grid will stay as is.

#### Multiple Records with Drop Position

```ts
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ICellRendererComp,
  ICellRendererParams,
  ModuleRegistry,
  RowDragModule,
  RowSelectionModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelApiModule,
  TextFilterModule,
  RowDragModule,
  RowSelectionModule,
  ClientSideRowModelModule,
]);

class SportRenderer implements ICellRendererComp {
  eGui!: HTMLElement;

  init(params: ICellRendererParams) {
    this.eGui = document.createElement("i");

    this.eGui.addEventListener("click", () => {
      params.api.applyTransaction({ remove: [params.node.data] });
    });

    this.eGui.classList.add("far", "fa-trash-alt");
    this.eGui.style.cursor = "pointer";
  }

  getGui() {
    return this.eGui;
  }

  refresh(params: ICellRendererParams): boolean {
    return false;
  }
}

const leftColumnDefs: ColDef[] = [
  {
    rowDrag: true,
    maxWidth: 50,
    suppressHeaderMenuButton: true,
    suppressHeaderFilterButton: true,
    rowDragText: (params, dragItemCount) => {
      if (dragItemCount > 1) {
        return dragItemCount + " athletes";
      }
      return params.rowNode!.data.athlete;
    },
  },
  { field: "athlete" },
  { field: "sport" },
];

const rightColumnDefs: ColDef[] = [
  {
    rowDrag: true,
    maxWidth: 50,
    suppressHeaderMenuButton: true,
    suppressHeaderFilterButton: true,
    rowDragText: (params, dragItemCount) => {
      if (dragItemCount > 1) {
        return dragItemCount + " athletes";
      }
      return params.rowNode!.data.athlete;
    },
  },
  { field: "athlete" },
  { field: "sport" },
  {
    suppressHeaderMenuButton: true,
    suppressHeaderFilterButton: true,
    maxWidth: 50,
    cellRenderer: SportRenderer,
  },
];
let leftApi: GridApi;
const leftGridOptions: GridOptions = {
  defaultColDef: {
    flex: 1,
    minWidth: 100,
    filter: true,
  },
  rowSelection: {
    mode: "multiRow",
  },
  rowDragMultiRow: true,
  getRowId: (params: GetRowIdParams) => {
    return params.data.athlete;
  },
  rowDragManaged: true,
  suppressMoveWhenRowDragging: true,
  columnDefs: leftColumnDefs,
  onGridReady: (params) => {
    addGridDropZone(params);
  },
};
let rightApi: GridApi;
const rightGridOptions: GridOptions = {
  defaultColDef: {
    flex: 1,
    minWidth: 100,
    filter: true,
  },
  getRowId: (params: GetRowIdParams) => {
    return params.data.athlete;
  },
  rowDragManaged: true,
  columnDefs: rightColumnDefs,
};

function addGridDropZone(params: GridReadyEvent) {
  const dropZoneParams = rightApi!.getRowDropZoneParams({
    onDragStop: (params) => {
      const deselectCheck = (
        document.querySelector("input#deselect") as HTMLInputElement
      ).checked;
      const moveCheck = (
        document.querySelector("input#move") as HTMLInputElement
      ).checked;
      const nodes = params.nodes;

      if (moveCheck) {
        leftApi!.applyTransaction({
          remove: nodes.map(function (node) {
            return node.data;
          }),
        });
      } else if (deselectCheck) {
        leftApi!.setNodesSelected({ nodes, newValue: false });
      }
    },
  });

  params.api.addRowDropZone(dropZoneParams);
}

function loadGrid(
  options: GridOptions,
  oldApi: GridApi,
  side: string,
  data: any[],
) {
  const grid = document.querySelector<HTMLElement>("#e" + side + "Grid")!;

  oldApi?.destroy();

  options.rowData = data;
  return createGrid(grid, options);
}

function resetInputs() {
  const inputs = document.querySelectorAll(
    ".example-toolbar input",
  ) as NodeListOf<HTMLInputElement>;
  const checkbox = inputs[inputs.length - 1];

  if (!checkbox.checked) {
    checkbox.click();
  }

  inputs[0].checked = true;
}

function loadGrids() {
  fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
    .then((response) => response.json())
    .then(function (data) {
      const athletes: any[] = [];
      let i = 0;

      while (athletes.length < 20 && i < data.length) {
        const pos = i++;
        if (
          athletes.some(function (rec) {
            return rec.athlete === data[pos].athlete;
          })
        ) {
          continue;
        }
        athletes.push(data[pos]);
      }

      leftApi = loadGrid(leftGridOptions, leftApi, "Left", athletes);
      rightApi = loadGrid(rightGridOptions, rightApi, "Right", []);
    });
}

const resetBtn = document.querySelector("button.reset")!;

resetBtn.addEventListener("click", () => {
  resetInputs();
  loadGrids();
});

loadGrids();
```

[Live example: Multiple Records with Drop Position](https://www.ag-grid.com/archive/36.2.0/examples/row-dragging-to-grid/two-grids-with-multiple-records/typescript/)


---
product: "AG Grid"
title: "Row Dragging Between Grids"
description: "Row Drag Between Grids is concerned with seamless integration among different grids, allowing records to be dragged from one grid and dropped at a specific index on another grid."
framework: react
version: "36.2.0"
related:
    - title: "Managed Row Dragging"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-dragging-managed/"
    - title: "Unmanaged Row Dragging"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-dragging-unmanaged/"
    - title: "Row Dragging Customisation"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-dragging-customisation/"
    - title: "External DropZone"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-dragging-to-external-dropzone/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Row Dragging Between Grids

Row Drag Between Grids is concerned with seamless integration among different grids, allowing records to be dragged from one grid and dropped at a specific index on another grid.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `addRowDropZone` | `Function` |  |  |  |
| `removeRowDropZone` | `Function` |  |  |  |
| `getRowDropZoneParams` | `Function` |  |  |  |

## Adding a Grid as Target

To allow adding a grid as DropZone, the `getRowDropZoneParams` API method should be used in the target grid and the `addRowDropZone` in the source grid.

```js
const dropZoneParams = targetGridApi.getRowDropZoneParams({
    onDragStop: function() {
        alert('Record Dropped!');
    }
});

if (dropZoneParams) {
    sourceGridApi.addRowDropZone(dropZoneParams);

    // when the DropZone above is no longer needed
    sourceGridApi.removeRowDropZone(dropZoneParams);
}
```

In the example below, note the following:

- When you drag from one grid to another, a line will appear indicating where the row will be placed.
- Rows can be dragged from one grid to the other grid. When the row is received, it is **not** removed from the first grid. This is the choice of the example. The example could equally have removed from the other grid.
- Rows can be removed from both grids by dragging the row to the 'Trash' drop zone.
- New rows can be created by clicking on the red, green and blue buttons.

#### Two Grids with Drop Position

```tsx
'use client';
import React, {
  StrictMode,
  useCallback,
  useEffect,
  useRef,
  useState,
} from "react";
import { createRoot } from "react-dom/client";

import type {
  ColDef,
  GetRowIdParams,
  GridApi,
  GridReadyEvent,
  RowDataTransaction,
  RowDropZoneParams,
} from "ag-grid-community";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  RowApiModule,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelApiModule,
  RowApiModule,
  TextFilterModule,
  RowDragModule,
  RowStyleModule,
  ClientSideRowModelModule,
];

const columns: ColDef[] = [
  { field: "id", rowDrag: true },
  { field: "color" },
  { field: "value1" },
  { field: "value2" },
];

const rowClassRules = {
  "red-row": 'data.color == "Red"',
  "green-row": 'data.color == "Green"',
  "blue-row": 'data.color == "Blue"',
};

const defaultColDef: ColDef = {
  flex: 1,
  minWidth: 100,
  filter: true,
};

const GridExample = () => {
  const [leftApi, setLeftApi] = useState<GridApi | null>(null);
  const [rightApi, setRightApi] = useState<GridApi | null>(null);
  const [leftRowData, setLeftRowData] = useState<any[]>([]);
  const [rightRowData, setRightRowData] = useState<any[]>([]);

  const eLeftGrid = useRef(null);
  const eRightGrid = useRef(null);
  const eBin = useRef<HTMLElement>(null);
  const eBinIcon = useRef<HTMLElement>(null);

  let rowIdSequence = 100;

  const createDataItem = useCallback(
    (color: string) => {
      const obj = {
        id: rowIdSequence++,
        color: color,
        value1: Math.floor(window.agRandom() * 100),
        value2: Math.floor(window.agRandom() * 100),
      };

      return obj;
    },
    [rowIdSequence],
  );

  useEffect(() => {
    const createRowBlock = (blocks: number) =>
      Array.apply(null, Array(blocks || 1))
        .map(() =>
          ["Red", "Green", "Blue"].map((color) => createDataItem(color)),
        )
        .reduce((prev, curr) => prev.concat(curr), []);

    setLeftRowData(createRowBlock(2));
    setRightRowData(createRowBlock(2));
  }, [createDataItem]);

  const getRowId = (params: GetRowIdParams) => String(params.data.id);

  const addRecordToGrid = (side: string, data: any) => {
    // if data missing or data has no it, do nothing
    if (!data || data.id == null) {
      return;
    }

    const api = side === "left" ? leftApi : rightApi;
    // do nothing if row is already in the grid, otherwise we would have duplicates
    const rowAlreadyInGrid = !!api!.getRowNode(data.id);
    let transaction: RowDataTransaction;

    if (rowAlreadyInGrid) {
      console.log("not adding row to avoid duplicates in the grid");
      return;
    }

    transaction = {
      add: [data],
    };

    api!.applyTransaction(transaction);
  };

  const onFactoryButtonClick = (e: any) => {
    const button = e.currentTarget,
      buttonColor = button.getAttribute("data-color"),
      side = button.getAttribute("data-side"),
      data = createDataItem(buttonColor);

    addRecordToGrid(side, data);
  };

  const binDrop = (data: any) => {
    // if data missing or data has no id, do nothing
    if (!data || data.id == null) {
      return;
    }

    const transaction = {
      remove: [data],
    };

    [leftApi, rightApi].forEach((api) => {
      const rowsInGrid = !!api!.getRowNode(data.id);

      if (rowsInGrid) {
        api!.applyTransaction(transaction);
      }
    });
  };

  const addBinZone = (api: GridApi) => {
    const dropZone: RowDropZoneParams = {
      getContainer: () => eBinIcon.current!,
      onDragEnter: () => {
        eBin.current!.style.color = "blue";
        eBinIcon.current!.style.transform = "scale(1.5)";
      },
      onDragLeave: () => {
        eBin.current!.style.color = "";
        eBinIcon.current!.style.transform = "scale(1)";
      },
      onDragStop: (params) => {
        binDrop(params.node.data);
        eBin.current!.style.color = "";
        eBinIcon.current!.style.transform = "scale(1)";
      },
    };

    api.addRowDropZone(dropZone);
  };

  const addGridDropZone = (side: string, api: GridApi) => {
    const dropApi = side === "Left" ? rightApi : leftApi;
    const dropZone = dropApi!.getRowDropZoneParams();

    api.addRowDropZone(dropZone);
  };

  useEffect(() => {
    if (rightApi && leftApi) {
      addBinZone(rightApi);
      addBinZone(leftApi);
      addGridDropZone("Right", rightApi);
      addGridDropZone("Left", leftApi);
    }
  });

  const onGridReady = (side: string, params: GridReadyEvent) => {
    if (side === "Left") {
      setLeftApi(params.api);
    } else {
      setRightApi(params.api);
    }
  };

  const getAddRecordButton = (side: string, color: string) => (
    <button
      key={`btn_${side}_${color}`}
      className={`factory factory-${color.toLowerCase()}`}
      data-color={color}
      data-side={side.toLowerCase()}
      onClick={onFactoryButtonClick}
    >
      <i className="far fa-plus-square"></i>
      {`Add ${color}`}
    </button>
  );

  const getInnerGridCol = (side: string) => (
    <div className="inner-col">
      <div className="toolbar">
        {["Red", "Green", "Blue"].map((color) =>
          getAddRecordButton(side, color),
        )}
      </div>
      <div
        style={{ height: "100%" }}
        className="inner-col"
        ref={side === "Left" ? eLeftGrid : eRightGrid}
      >
        <AgGridReact
          defaultColDef={defaultColDef}
          getRowId={getRowId}
          rowClassRules={rowClassRules}
          rowDragManaged={true}
          suppressMoveWhenRowDragging={true}
          rowData={side === "Left" ? leftRowData : rightRowData}
          columnDefs={[...columns]}
          onGridReady={(params: GridReadyEvent) => onGridReady(side, params)}
        />
      </div>
    </div>
  );

  return (
    <AgGridProvider modules={modules}>
      <div className="example-wrapper">
        {getInnerGridCol("Left")}
        <div className="inner-col vertical-toolbar">
          <span className="bin" ref={eBin}>
            <i className="far fa-trash-alt fa-3x" ref={eBinIcon}></i>
          </span>
        </div>
        {getInnerGridCol("Right")}
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Two Grids with Drop Position](https://www.ag-grid.com/archive/36.2.0/examples/row-dragging-to-grid/two-grids-with-drop-position/reactFunctionalTs/)

## Dragging Multiple Records Between Grids

It is possible to drag multiple records at once from one grid to another.

In the example below, note the following:

- This example enables [Multi-Row Dragging](https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-dragging-managed/#multi-row-dragging) between grids using `rowDragMultiRow`.
- When `Remove Source Rows` is selected, the rows will be removed from the **Athletes** grid once they are dropped onto the **Selected Athletes** grid.
- If `Only Deselect Source Rows` is selected, all selected rows that were copied will be deselected but will not be removed.
   Note: If some rows are selected and a row that isn't selected is copied, the selected rows will remain selected.
- If `None` is selected, the rows will be copied from one grid to another and the source grid will stay as is.

#### Multiple Records with Drop Position

```tsx
'use client';
import React, { StrictMode, useCallback, useEffect, useState } from "react";
import { createRoot } from "react-dom/client";

import type {
  ColDef,
  GetRowIdParams,
  GridApi,
  GridReadyEvent,
  RowDragEndEvent,
  RowSelectionOptions,
} from "ag-grid-community";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  RowDragModule,
  RowSelectionModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import type { CustomCellRendererProps } from "ag-grid-react";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelApiModule,
  TextFilterModule,
  RowDragModule,
  RowSelectionModule,
  ClientSideRowModelModule,
];

const SportRenderer = (props: CustomCellRendererProps) => {
  return (
    <i
      className="far fa-trash-alt"
      style={{ cursor: "pointer" }}
      onClick={() => props.api.applyTransaction({ remove: [props.node.data] })}
    ></i>
  );
};

const leftColumns: ColDef[] = [
  {
    rowDrag: true,
    maxWidth: 50,
    suppressHeaderMenuButton: true,
    suppressHeaderFilterButton: true,
    rowDragText: (params, dragItemCount) => {
      if (dragItemCount > 1) {
        return dragItemCount + " athletes";
      }
      return params.rowNode!.data.athlete;
    },
  },
  { field: "athlete" },
  { field: "sport" },
];

const rightColumns: ColDef[] = [
  {
    rowDrag: true,
    maxWidth: 50,
    suppressHeaderMenuButton: true,
    suppressHeaderFilterButton: true,
    rowDragText: (params, dragItemCount) => {
      if (dragItemCount > 1) {
        return dragItemCount + " athletes";
      }
      return params.rowNode!.data.athlete;
    },
  },
  { field: "athlete" },
  { field: "sport" },
  {
    suppressHeaderMenuButton: true,
    suppressHeaderFilterButton: true,
    maxWidth: 50,
    cellRenderer: SportRenderer,
  },
];

const defaultColDef: ColDef = {
  flex: 1,
  minWidth: 100,
  filter: true,
};

const rowSelection: RowSelectionOptions = {
  mode: "multiRow",
};

const GridExample = () => {
  const [leftApi, setLeftApi] = useState<GridApi | null>(null);
  const [rightApi, setRightApi] = useState<GridApi | null>(null);
  const [rawData, setRawData] = useState<any[]>([]);
  const [leftRowData, setLeftRowData] = useState<any[] | null>(null);
  const [rightRowData, setRightRowData] = useState<any[]>([]);
  const [radioChecked, setRadioChecked] = useState(0);

  useEffect(() => {
    if (!rawData.length) {
      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => {
          const athletes: any[] = [];
          let i = 0;

          while (athletes.length < 20 && i < data.length) {
            var pos = i++;
            if (athletes.some((rec) => rec.athlete === data[pos].athlete)) {
              continue;
            }
            athletes.push(data[pos]);
          }
          setRawData(athletes);
        });
    }
  }, [rawData]);

  const loadGrids = useCallback(() => {
    setLeftRowData([...rawData]);
    setRightRowData([]);
    leftApi?.deselectAll();
  }, [leftApi, rawData]);

  useEffect(() => {
    if (rawData.length) {
      loadGrids();
    }
  }, [rawData, loadGrids]);

  const reset = () => {
    setRadioChecked(0);
    loadGrids();
  };

  const onRadioChange = (e: any) => {
    setRadioChecked(parseInt(e.target.value, 10));
  };

  const getRowId = (params: GetRowIdParams) => params.data.athlete;

  const onDragStop = useCallback(
    (params: RowDragEndEvent) => {
      const nodes = params.nodes;

      if (radioChecked === 0) {
        leftApi!.applyTransaction({
          remove: nodes.map(function (node) {
            return node.data;
          }),
        });
      } else if (radioChecked === 1) {
        leftApi!.setNodesSelected({ nodes, newValue: false });
      }
    },
    [leftApi, radioChecked],
  );

  useEffect(() => {
    if (!leftApi || !rightApi) {
      return;
    }
    const dropZoneParams = rightApi.getRowDropZoneParams({ onDragStop });

    leftApi.removeRowDropZone(dropZoneParams);
    leftApi.addRowDropZone(dropZoneParams);
  }, [leftApi, rightApi, onDragStop]);

  const onGridReady = (params: GridReadyEvent, side: number) => {
    if (side === 0) {
      setLeftApi(params.api);
    }

    if (side === 1) {
      setRightApi(params.api);
    }
  };

  const getTopToolBar = () => (
    <div className="example-toolbar panel panel-default">
      <div className="panel-body">
        <div onChange={onRadioChange}>
          <input
            type="radio"
            id="move"
            name="radio"
            value="0"
            checked={radioChecked === 0}
          />{" "}
          <label htmlFor="move">Remove Source Rows</label>
          <input
            type="radio"
            id="deselect"
            name="radio"
            value="1"
            checked={radioChecked === 1}
          />{" "}
          <label htmlFor="deselect">Only Deselect Source Rows</label>
          <input
            type="radio"
            id="none"
            name="radio"
            value="2"
            checked={radioChecked === 2}
          />{" "}
          <label htmlFor="none">None</label>
        </div>
        <span className="input-group-button">
          <button
            type="button"
            className="btn btn-default reset"
            style={{ marginLeft: "5px" }}
            onClick={reset}
          >
            <i className="fas fa-redo" style={{ marginRight: "5px" }}></i>Reset
          </button>
        </span>
      </div>
    </div>
  );

  const getGridWrapper = (id: number) => (
    <div className="panel panel-primary" style={{ marginRight: "10px" }}>
      <div className="panel-heading">
        {id === 0 ? "Athletes" : "Selected Athletes"}
      </div>
      <div className="panel-body" style={{ height: "100%" }}>
        <AgGridReact
          defaultColDef={defaultColDef}
          getRowId={getRowId}
          rowDragManaged={true}
          rowSelection={id === 0 ? rowSelection : undefined}
          rowDragMultiRow={id === 0}
          suppressMoveWhenRowDragging={id === 0}
          rowData={id === 0 ? leftRowData : rightRowData}
          columnDefs={id === 0 ? leftColumns : rightColumns}
          onGridReady={(params) => onGridReady(params, id)}
        />
      </div>
    </div>
  );

  return (
    <AgGridProvider modules={modules}>
      <div className="top-container">
        {getTopToolBar()}
        <div className="grid-wrapper">
          {getGridWrapper(0)}
          {getGridWrapper(1)}
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Multiple Records with Drop Position](https://www.ag-grid.com/archive/36.2.0/examples/row-dragging-to-grid/two-grids-with-multiple-records/reactFunctionalTs/)


---
product: "AG Grid"
title: "Row Dragging Between Grids"
description: "Row Drag Between Grids is concerned with seamless integration among different grids, allowing records to be dragged from one grid and dropped at a specific index on another grid."
framework: vue
version: "36.2.0"
related:
    - title: "Managed Row Dragging"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-dragging-managed/"
    - title: "Unmanaged Row Dragging"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-dragging-unmanaged/"
    - title: "Row Dragging Customisation"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-dragging-customisation/"
    - title: "External DropZone"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-dragging-to-external-dropzone/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Row Dragging Between Grids

Row Drag Between Grids is concerned with seamless integration among different grids, allowing records to be dragged from one grid and dropped at a specific index on another grid.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `addRowDropZone` | `Function` |  |  |  |
| `removeRowDropZone` | `Function` |  |  |  |
| `getRowDropZoneParams` | `Function` |  |  |  |

## Adding a Grid as Target

To allow adding a grid as DropZone, the `getRowDropZoneParams` API method should be used in the target grid and the `addRowDropZone` in the source grid.

```js
const dropZoneParams = targetGridApi.getRowDropZoneParams({
    onDragStop: function() {
        alert('Record Dropped!');
    }
});

if (dropZoneParams) {
    sourceGridApi.addRowDropZone(dropZoneParams);

    // when the DropZone above is no longer needed
    sourceGridApi.removeRowDropZone(dropZoneParams);
}
```

In the example below, note the following:

- When you drag from one grid to another, a line will appear indicating where the row will be placed.
- Rows can be dragged from one grid to the other grid. When the row is received, it is **not** removed from the first grid. This is the choice of the example. The example could equally have removed from the other grid.
- Rows can be removed from both grids by dragging the row to the 'Trash' drop zone.
- New rows can be created by clicking on the red, green and blue buttons.

#### Two Grids with Drop Position

```ts
import { createApp, defineComponent } from "vue";

import type {
  ColDef,
  GetRowIdParams,
  GridApi,
  GridReadyEvent,
  RowClassRules,
  RowDropZoneParams,
} from "ag-grid-community";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ModuleRegistry,
  RowApiModule,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridVue } from "ag-grid-vue3";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowDragModule,
  ClientSideRowModelApiModule,
  RowApiModule,
  TextFilterModule,
  RowStyleModule,
  ClientSideRowModelModule,
]);

let rowIdSequence = 100;

function createDataItem(color) {
  const obj = {
    id: rowIdSequence++,
    color: color,
    value1: Math.floor(window.agRandom() * 100),
    value2: Math.floor(window.agRandom() * 100),
  };

  return obj;
}

const createRowBlock = (blocks) =>
  Array.apply(null, Array(blocks || 1))
    .map(() => ["Red", "Green", "Blue"].map((color) => createDataItem(color)))
    .reduce((prev, curr) => prev.concat(curr), []);

const VueExample = defineComponent({
  /* html */
  template: `<div class="example-wrapper">

            <div class="inner-col">
                <div class="toolbar">
                    <button class="factory factory-red" data-color="Red" data-side="left" @click="onFactoryButtonClick($event)">
                        <i class="far fa-plus-square"></i>Add Red
                    </button>
                    <button class="factory factory-green" data-color="Green" data-side="left" @click="onFactoryButtonClick($event)">
                        <i class="far fa-plus-square"></i>Add Green
                    </button>
                    <button class="factory factory-blue" data-color="Blue" data-side="left" @click="onFactoryButtonClick($event)">
                        <i class="far fa-plus-square"></i>Add Blue
                    </button>
                </div>
                <div style="height: 100%;" class="inner-col" ref="eLeftGrid">
                    <ag-grid-vue
                        style="height: 100%;"
                        :defaultColDef="defaultColDef"
                        :getRowId="getRowId"
                        :rowClassRules="rowClassRules"
                        :rowDragManaged="true"
                        :suppressMoveWhenRowDragging="true"
                        :rowData="leftRowData"
                        :columnDefs="columns"
                        @grid-ready="onGridReady($event, 'Left')"
                        >
                    </ag-grid-vue>
                </div>
            </div>

            <div class="inner-col vertical-toolbar">
                <span class="bin" ref="eBin">
                    <i class="far fa-trash-alt fa-3x" ref="eBinIcon"></i>
                </span>
            </div>

            <div class="inner-col">
                <div class="toolbar">
                    <button class="factory factory-red" data-color="Red" data-side="right" @click="onFactoryButtonClick($event)">
                        <i class="far fa-plus-square"></i>Add Red
                    </button>
                    <button class="factory factory-green" data-color="Green" data-side="right" @click="onFactoryButtonClick($event)">
                        <i class="far fa-plus-square"></i>Add Green
                    </button>
                    <button class="factory factory-blue" data-color="Blue" data-side="right" @click="onFactoryButtonClick($event)">
                        <i class="far fa-plus-square"></i>Add Blue
                    </button>
                </div>
                <div style="height: 100%;" class="inner-col" ref="eRightGrid">
                    <ag-grid-vue
                        style="height: 100%;"
                        :defaultColDef="defaultColDef"
                        :getRowId="getRowId"
                        :rowClassRules="rowClassRules"
                        :rowDragManaged="true"
                        :suppressMoveWhenRowDragging="true"
                        :rowData="rightRowData"
                        :columnDefs="columns"
                        @grid-ready="onGridReady($event, 'Right')"
                        >
                    </ag-grid-vue>
                </div>
            </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  data: function () {
    return {
      leftRowData: [],
      rightRowData: [],
      leftApi: null,
      rightApi: null,
      rowClassRules: <RowClassRules>{
        "red-row": 'data.color == "Red"',
        "green-row": 'data.color == "Green"',
        "blue-row": 'data.color == "Blue"',
      },
      defaultColDef: <ColDef>{
        flex: 1,
        minWidth: 100,
        filter: true,
      },
      columns: <ColDef[]>[
        { field: "id", rowDrag: true },
        { field: "color" },
        { field: "value1" },
        { field: "value2" },
      ],
    };
  },
  beforeMount() {
    this.leftRowData = createRowBlock(2);
    this.rightRowData = createRowBlock(2);
  },
  methods: {
    getRowId(params: GetRowIdParams) {
      return String(params.data.id);
    },

    onGridReady(params: GridReadyEvent, side: number) {
      const api = params.api;
      if (side === "Left") {
        this.leftApi = api;
      } else {
        this.rightApi = api;
      }

      if (this.leftApi && this.rightApi) {
        this.addBinZone(this.leftApi);
        this.addBinZone(this.rightApi);
        this.addGridDropZone("Left", this.leftApi);
        this.addGridDropZone("Right", this.rightApi);
      }
    },

    addRecordToGrid(side, data) {
      // if data missing or data has no it, do nothing
      if (!data || data.id == null) {
        return;
      }

      const api = side === "left" ? this.leftApi : this.rightApi;
      // do nothing if row is already in the grid, otherwise we would have duplicates
      const rowAlreadyInGrid = !!api.getRowNode(data.id);
      let transaction;

      if (rowAlreadyInGrid) {
        console.log("not adding row to avoid duplicates in the grid");
        return;
      }

      transaction = {
        add: [data],
      };

      api.applyTransaction(transaction);
    },

    onFactoryButtonClick(e) {
      var button = e.currentTarget,
        buttonColor = button.getAttribute("data-color"),
        side = button.getAttribute("data-side"),
        data = createDataItem(buttonColor);

      this.addRecordToGrid(side, data);
    },

    binDrop(data) {
      // if data missing or data has no id, do nothing
      if (!data || data.id == null) {
        return;
      }

      var transaction = {
        remove: [data],
      };

      [this.leftApi, this.rightApi].forEach((api) => {
        var rowsInGrid = !!api.getRowNode(data.id);

        if (rowsInGrid) {
          api.applyTransaction(transaction);
        }
      });
    },

    addBinZone(api: GridApi) {
      const dropZone = <RowDropZoneParams>{
        getContainer: () => this.$refs.eBinIcon,
        onDragEnter: () => {
          this.$refs.eBin.style.color = "blue";
          this.$refs.eBinIcon.style.transform = "scale(1.5)";
        },
        onDragLeave: () => {
          this.$refs.eBin.style = "";
          this.$refs.eBinIcon.style.transform = "scale(1)";
        },
        onDragStop: (params) => {
          this.binDrop(params.node.data);
          this.$refs.eBin.style = "";
          this.$refs.eBinIcon.style.transform = "scale(1)";
        },
      };

      api.addRowDropZone(dropZone);
    },

    addGridDropZone(side, api) {
      const dropApi = side === "Left" ? this.rightApi : this.leftApi;
      const dropZone = dropApi.getRowDropZoneParams();

      api.addRowDropZone(dropZone);
    },
  },
});

createApp(VueExample).mount("#app");
```

[Live example: Two Grids with Drop Position](https://www.ag-grid.com/archive/36.2.0/examples/row-dragging-to-grid/two-grids-with-drop-position/vue3/)

## Dragging Multiple Records Between Grids

It is possible to drag multiple records at once from one grid to another.

In the example below, note the following:

- This example enables [Multi-Row Dragging](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-dragging-managed/#multi-row-dragging) between grids using `rowDragMultiRow`.
- When `Remove Source Rows` is selected, the rows will be removed from the **Athletes** grid once they are dropped onto the **Selected Athletes** grid.
- If `Only Deselect Source Rows` is selected, all selected rows that were copied will be deselected but will not be removed.
   Note: If some rows are selected and a row that isn't selected is copied, the selected rows will remain selected.
- If `None` is selected, the rows will be copied from one grid to another and the source grid will stay as is.

#### Multiple Records with Drop Position

```ts
import { createApp, defineComponent } from "vue";

import type {
  ColDef,
  GetRowIdParams,
  GridApi,
  GridReadyEvent,
  ICellRendererParams,
  RowDropZoneParams,
  RowSelectionOptions,
} from "ag-grid-community";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ModuleRegistry,
  RowDragModule,
  RowSelectionModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridVue } from "ag-grid-vue3";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowDragModule,
  ClientSideRowModelApiModule,
  TextFilterModule,
  RowSelectionModule,
  ClientSideRowModelModule,
]);

const SportRenderer = defineComponent({
  template: `<i class="far fa-trash-alt" style="cursor: pointer" @click="applyTransaction()"></i>`,
  methods: {
    applyTransaction() {
      this.params.api.applyTransaction({ remove: [this.params.node.data] });
    },
  },
});

const VueExample = defineComponent({
  template: /* html */ `
        <div class="top-container">
            <div class="example-toolbar panel panel-default">
                <div class="panel-body">
                    <input type="radio" id="move" name="radio" checked ref="eMoveRadio">
                    <label for="move">Remove Source Rows</label>
                    <input type="radio" id="deselect" name="radio" ref="eDeselectRadio">
                    <label for="deselect">Only Deselect Source Rows</label>
                    <input type="radio" id="none" name="radio">
                    <label for="none">None</label>
                    <span class="input-group-button">
                        <button type="button" class="btn btn-default reset" style="margin-left: 5px;" @click="reset()">
                            <i class="fas fa-redo" style="margin-right: 5px;"></i>Reset
                        </button>
                    </span>
                </div>
            </div>
            <div class="grid-wrapper">
                <div class="panel panel-primary" style="margin-right: 10px;">
                    <div class="panel-heading">Athletes</div>
                    <div class="panel-body">
                        <ag-grid-vue
                                style="height: 100%;"
                                :defaultColDef="defaultColDef"
                                :rowSelection="rowSelection"
                                :rowDragMultiRow="true"
                                :getRowId="getRowId"
                                :rowDragManaged="true"
                                :suppressMoveWhenRowDragging="true"
                                :rowData="leftRowData"
                                :columnDefs="leftColumns"
                                @grid-ready="onGridReady($event, 0)"
                                >
                        </ag-grid-vue>
                    </div>
                </div>
                <div class="panel panel-primary" style="margin-left: 10px;">
                    <div class="panel-heading">Selected Athletes</div>
                    <div class="panel-body">
                        <ag-grid-vue
                                style="height: 100%;"
                                :defaultColDef="defaultColDef"
                                :getRowId="getRowId"
                                :rowDragManaged="true"
                                :rowData="rightRowData"
                                :columnDefs="rightColumns"
                                @grid-ready="onGridReady($event, 1)"
                                >
                        </ag-grid-vue>
                    </div>
                </div>
            </div>
        </div>`,
  components: {
    "ag-grid-vue": AgGridVue,
    SportRenderer,
  },
  data: function () {
    return {
      leftRowData: null,
      rightRowData: [],
      rawData: [],
      leftApi: null,
      rightApi: null,

      defaultColDef: <ColDef>{
        flex: 1,
        minWidth: 100,
        filter: true,
      },
      rowSelection: <RowSelectionOptions>{
        mode: "multiRow",
      },
      leftColumns: <ColDef[]>[
        {
          rowDrag: true,
          maxWidth: 50,
          suppressHeaderMenuButton: true,
          suppressHeaderFilterButton: true,
          rowDragText: (params, dragItemCount) => {
            if (dragItemCount > 1) {
              return dragItemCount + " athletes";
            }
            return params.rowNode.data.athlete;
          },
        },
        { field: "athlete" },
        { field: "sport" },
      ],
      rightColumns: <ColDef[]>[
        {
          rowDrag: true,
          maxWidth: 50,
          suppressHeaderMenuButton: true,
          suppressHeaderFilterButton: true,
          rowDragText: (params, dragItemCount) => {
            if (dragItemCount > 1) {
              return dragItemCount + " athletes";
            }
            return params.rowNode.data.athlete;
          },
        },
        { field: "athlete" },
        { field: "sport" },
        {
          suppressHeaderMenuButton: true,
          suppressHeaderFilterButton: true,
          maxWidth: 50,
          cellRenderer: "SportRenderer",
        },
      ],
    };
  },
  beforeMount() {
    fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data) => {
        const athletes = [];
        let i = 0;

        while (athletes.length < 20 && i < data.length) {
          var pos = i++;
          if (athletes.some((rec) => rec.athlete === data[pos].athlete)) {
            continue;
          }
          athletes.push(data[pos]);
        }
        this.rawData = athletes;
        this.loadGrids();
      });
  },
  methods: {
    getRowId(params: GetRowIdParams) {
      return params.data.athlete;
    },

    loadGrids() {
      this.leftRowData = [...this.rawData];
      this.rightRowData = [];
    },

    reset() {
      this.$refs.eMoveRadio.checked = true;

      this.loadGrids();
    },

    onGridReady(params: GridReadyEvent, side: number) {
      if (side === 0) {
        this.leftApi = params.api;
      }

      if (side === 1) {
        this.rightApi = params.api;
        this.addGridDropZone();
      }
    },

    addGridDropZone() {
      const dropZoneParams = <RowDropZoneParams>(
        this.rightApi.getRowDropZoneParams({
          onDragStop: (params) => {
            var deselectCheck = this.$refs.eDeselectRadio.checked;
            var moveCheck = this.$refs.eMoveRadio.checked;
            var nodes = params.nodes;

            if (moveCheck) {
              this.leftApi.applyTransaction({
                remove: nodes.map(function (node) {
                  return node.data;
                }),
              });
            } else if (deselectCheck) {
              this.leftApi.setNodesSelected({ nodes, newValue: false });
            }
          },
        })
      );

      this.leftApi.addRowDropZone(dropZoneParams);
    },
  },
});

createApp(VueExample).mount("#app");
```

[Live example: Multiple Records with Drop Position](https://www.ag-grid.com/archive/36.2.0/examples/row-dragging-to-grid/two-grids-with-multiple-records/vue3/)


---
product: "AG Grid"
title: "Row Dragging Between Grids"
description: "Row Drag Between Grids is concerned with seamless integration among different grids, allowing records to be dragged from one grid and dropped at a specific index on another grid."
framework: angular
version: "36.2.0"
related:
    - title: "Managed Row Dragging"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-dragging-managed/"
    - title: "Unmanaged Row Dragging"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-dragging-unmanaged/"
    - title: "Row Dragging Customisation"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-dragging-customisation/"
    - title: "External DropZone"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-dragging-to-external-dropzone/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Row Dragging Between Grids

Row Drag Between Grids is concerned with seamless integration among different grids, allowing records to be dragged from one grid and dropped at a specific index on another grid.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `addRowDropZone` | `Function` |  |  |  |
| `removeRowDropZone` | `Function` |  |  |  |
| `getRowDropZoneParams` | `Function` |  |  |  |

## Adding a Grid as Target

To allow adding a grid as DropZone, the `getRowDropZoneParams` API method should be used in the target grid and the `addRowDropZone` in the source grid.

```js
const dropZoneParams = targetGridApi.getRowDropZoneParams({
    onDragStop: function() {
        alert('Record Dropped!');
    }
});

if (dropZoneParams) {
    sourceGridApi.addRowDropZone(dropZoneParams);

    // when the DropZone above is no longer needed
    sourceGridApi.removeRowDropZone(dropZoneParams);
}
```

In the example below, note the following:

- When you drag from one grid to another, a line will appear indicating where the row will be placed.
- Rows can be dragged from one grid to the other grid. When the row is received, it is **not** removed from the first grid. This is the choice of the example. The example could equally have removed from the other grid.
- Rows can be removed from both grids by dragging the row to the 'Trash' drop zone.
- New rows can be created by clicking on the red, green and blue buttons.

#### Two Grids with Drop Position

```ts
import { Component, ViewChild } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import type {
  ColDef,
  GetRowIdParams,
  GridApi,
  GridReadyEvent,
  RowDropZoneParams,
} from "ag-grid-community";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ModuleRegistry,
  RowApiModule,
  RowDragModule,
  RowStyleModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowDragModule,
  ClientSideRowModelApiModule,
  RowApiModule,
  TextFilterModule,
  RowStyleModule,
  ClientSideRowModelModule,
]);
@Component({
  standalone: true,
  imports: [AgGridAngular],
  selector: "my-app",
  template: `
    <div class="example-wrapper">
      <div class="inner-col">
        <div class="toolbar">
          <button
            class="factory factory-red"
            data-color="Red"
            data-side="left"
            (click)="onFactoryButtonClick($event)"
          >
            <i class="far fa-plus-square"></i>Add Red
          </button>
          <button
            class="factory factory-green"
            data-color="Green"
            data-side="left"
            (click)="onFactoryButtonClick($event)"
          >
            <i class="far fa-plus-square"></i>Add Green
          </button>
          <button
            class="factory factory-blue"
            data-color="Blue"
            data-side="left"
            (click)="onFactoryButtonClick($event)"
          >
            <i class="far fa-plus-square"></i>Add Blue
          </button>
        </div>
        <div style="height: 100%;" class="inner-col" #eLeftGrid>
          <ag-grid-angular
            style="height: 100%;"
            [defaultColDef]="defaultColDef"
            [getRowId]="getRowId"
            [rowClassRules]="rowClassRules"
            [rowDragManaged]="true"
            [suppressMoveWhenRowDragging]="true"
            [rowData]="leftRowData"
            [columnDefs]="columns"
            (gridReady)="onGridReady($event, 'Left')"
          />
        </div>
      </div>

      <div class="inner-col vertical-toolbar">
        <span class="bin" #eBin>
          <i class="far fa-trash-alt fa-3x" #eBinIcon></i>
        </span>
      </div>

      <div class="inner-col">
        <div class="toolbar">
          <button
            class="factory factory-red"
            data-color="Red"
            data-side="right"
            (click)="onFactoryButtonClick($event)"
          >
            <i class="far fa-plus-square"></i>Add Red
          </button>
          <button
            class="factory factory-green"
            data-color="Green"
            data-side="right"
            (click)="onFactoryButtonClick($event)"
          >
            <i class="far fa-plus-square"></i>Add Green
          </button>
          <button
            class="factory factory-blue"
            data-color="Blue"
            data-side="right"
            (click)="onFactoryButtonClick($event)"
          >
            <i class="far fa-plus-square"></i>Add Blue
          </button>
        </div>
        <div style="height: 100%;" class="inner-col" #eRightGrid>
          <ag-grid-angular
            style="height: 100%;"
            [defaultColDef]="defaultColDef"
            [getRowId]="getRowId"
            [rowClassRules]="rowClassRules"
            [rowDragManaged]="true"
            [suppressMoveWhenRowDragging]="true"
            [rowData]="rightRowData"
            [columnDefs]="columns"
            (gridReady)="onGridReady($event, 'Right')"
          />
        </div>
      </div>
    </div>
  `,
})
export class AppComponent {
  leftRowData: any[] = [];
  rightRowData: any[] = [];
  leftApi!: GridApi;
  rightApi!: GridApi;

  rowClassRules = {
    "red-row": 'data.color == "Red"',
    "green-row": 'data.color == "Green"',
    "blue-row": 'data.color == "Blue"',
  };

  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
    filter: true,
  };

  columns: ColDef[] = [
    { field: "id", rowDrag: true },
    { field: "color" },
    { field: "value1" },
    { field: "value2" },
  ];

  @ViewChild("eLeftGrid") eLeftGrid: any;
  @ViewChild("eRightGrid") eRightGrid: any;
  @ViewChild("eBin") eBin: any;
  @ViewChild("eBinIcon") eBinIcon: any;

  constructor() {
    this.leftRowData = createRowBlock(2);
    this.rightRowData = createRowBlock(2);
  }

  getRowId = (params: GetRowIdParams) => {
    return String(params.data.id);
  };

  onGridReady(params: GridReadyEvent, side: string) {
    const api = params.api;
    if (side === "Left") {
      this.leftApi = api;
    } else {
      this.rightApi = api;
    }

    if (this.leftApi && this.rightApi) {
      this.addBinZone(this.leftApi);
      this.addBinZone(this.rightApi);
      this.addGridDropZone("Left", this.leftApi);
      this.addGridDropZone("Right", this.rightApi);
    }
  }

  addRecordToGrid(side: string, data: any) {
    // if data missing or data has no it, do nothing
    if (!data || data.id == null) {
      return;
    }

    const api = side === "left" ? this.leftApi : this.rightApi;
    // do nothing if row is already in the grid, otherwise we would have duplicates
    const rowAlreadyInGrid = !!api.getRowNode(data.id);

    if (rowAlreadyInGrid) {
      console.log("not adding row to avoid duplicates in the grid");
      return;
    }

    const transaction = {
      add: [data],
    };

    api.applyTransaction(transaction);
  }

  onFactoryButtonClick(e: any) {
    const button = e.currentTarget,
      buttonColor = button.getAttribute("data-color"),
      side = button.getAttribute("data-side"),
      data = createDataItem(buttonColor);

    this.addRecordToGrid(side, data);
  }

  binDrop(data: any) {
    // if data missing or data has no id, do nothing
    if (!data || data.id == null) {
      return;
    }

    const transaction = {
      remove: [data],
    };

    [this.leftApi, this.rightApi].forEach((api) => {
      const rowsInGrid = !!api.getRowNode(data.id);

      if (rowsInGrid) {
        api.applyTransaction(transaction);
      }
    });
  }

  addBinZone(api: GridApi) {
    const dropZone: RowDropZoneParams = {
      getContainer: () => this.eBinIcon.nativeElement,
      onDragEnter: () => {
        this.eBin.nativeElement.style.color = "blue";
        this.eBinIcon.nativeElement.style.transform = "scale(1.5)";
      },
      onDragLeave: () => {
        this.eBin.nativeElement.style = "";
        this.eBinIcon.nativeElement.style.transform = "scale(1)";
      },
      onDragStop: (params) => {
        this.binDrop(params.node.data);
        this.eBin.nativeElement.style = "";
        this.eBinIcon.nativeElement.style.transform = "scale(1)";
      },
    };

    api.addRowDropZone(dropZone);
  }

  addGridDropZone(side: string, api: GridApi) {
    const dropApi = side === "Left" ? this.rightApi : this.leftApi;
    const dropZone = dropApi.getRowDropZoneParams();

    api.addRowDropZone(dropZone!);
  }
}

let rowIdSequence = 100;

function createDataItem(color: string) {
  const obj = {
    id: rowIdSequence++,
    color: color,
    value1: Math.floor(window.agRandom() * 100),
    value2: Math.floor(window.agRandom() * 100),
  };

  return obj;
}

const createRowBlock = (blocks: any) =>
  Array.apply(null, Array(blocks || 1))
    .map(() => ["Red", "Green", "Blue"].map((color) => createDataItem(color)))
    .reduce((prev, curr) => prev.concat(curr), []);
```

[Live example: Two Grids with Drop Position](https://www.ag-grid.com/archive/36.2.0/examples/row-dragging-to-grid/two-grids-with-drop-position/angular/)

## Dragging Multiple Records Between Grids

It is possible to drag multiple records at once from one grid to another.

In the example below, note the following:

- This example enables [Multi-Row Dragging](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-dragging-managed/#multi-row-dragging) between grids using `rowDragMultiRow`.
- When `Remove Source Rows` is selected, the rows will be removed from the **Athletes** grid once they are dropped onto the **Selected Athletes** grid.
- If `Only Deselect Source Rows` is selected, all selected rows that were copied will be deselected but will not be removed.
   Note: If some rows are selected and a row that isn't selected is copied, the selected rows will remain selected.
- If `None` is selected, the rows will be copied from one grid to another and the source grid will stay as is.

#### Multiple Records with Drop Position

```ts
import { HttpClient } from "@angular/common/http";
import { ChangeDetectionStrategy, Component, ViewChild } from "@angular/core";

import type { ICellRendererAngularComp } from "ag-grid-angular";
import { AgGridAngular } from "ag-grid-angular";
import type {
  ColDef,
  GetRowIdParams,
  GridApi,
  GridReadyEvent,
  ICellRendererParams,
  RowSelectionOptions,
} from "ag-grid-community";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ModuleRegistry,
  RowDragModule,
  RowSelectionModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowDragModule,
  ClientSideRowModelApiModule,
  TextFilterModule,
  RowSelectionModule,
  ClientSideRowModelModule,
]);
@Component({
  standalone: true,
  changeDetection: ChangeDetectionStrategy.OnPush,
  template: ` <i
    class="far fa-trash-alt"
    style="cursor: pointer"
    (click)="applyTransaction()"
  ></i>`,
})
export class SportRenderer implements ICellRendererAngularComp {
  private params!: ICellRendererParams;

  agInit(params: ICellRendererParams): void {
    this.params = params;
  }

  applyTransaction() {
    this.params.api.applyTransaction({ remove: [this.params.node.data] });
  }

  refresh() {
    return false;
  }
}

@Component({
  standalone: true,
  imports: [AgGridAngular],
  selector: "my-app",
  template: /*html */ ` <div class="top-container">
    <div class="example-toolbar panel panel-default">
      <div class="panel-body">
        <input type="radio" id="move" name="radio" checked #eMoveRadio />
        <label for="move">Remove Source Rows</label>
        <input type="radio" id="deselect" name="radio" #eDeselectRadio />
        <label for="deselect">Only Deselect Source Rows</label>
        <input type="radio" id="none" name="radio" />
        <label for="none">None</label>
        <span class="input-group-button">
          <button
            type="button"
            class="btn btn-default reset"
            style="margin-left: 5px;"
            (click)="reset()"
          >
            <i class="fas fa-redo" style="margin-right: 5px;"></i>Reset
          </button>
        </span>
      </div>
    </div>
    <div class="grid-wrapper">
      <div class="panel panel-primary" style="margin-right: 10px;">
        <div class="panel-heading">Athletes</div>
        <div class="panel-body">
          <div id="eLeftGrid">
            <ag-grid-angular
              style="height: 100%;"
              [defaultColDef]="defaultColDef"
              [rowSelection]="rowSelection"
              [rowDragMultiRow]="true"
              [getRowId]="getRowId"
              [rowDragManaged]="true"
              [suppressMoveWhenRowDragging]="true"
              [rowData]="leftRowData"
              [columnDefs]="leftColumns"
              (gridReady)="onGridReady($event, 0)"
            />
          </div>
        </div>
      </div>
      <div class="panel panel-primary" style="margin-left: 10px;">
        <div class="panel-heading">Selected Athletes</div>
        <div class="panel-body">
          <div id="eRightGrid">
            <ag-grid-angular
              style="height: 100%;"
              [defaultColDef]="defaultColDef"
              [getRowId]="getRowId"
              [rowDragManaged]="true"
              [rowData]="rightRowData"
              [columnDefs]="rightColumns"
              (gridReady)="onGridReady($event, 1)"
            />
          </div>
        </div>
      </div>
    </div>
  </div>`,
})
export class AppComponent {
  rawData: any[] = [];
  leftRowData: any[] = [];
  rightRowData: any[] = [];
  leftApi!: GridApi;
  rightApi!: GridApi;

  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
    filter: true,
  };

  rowSelection: RowSelectionOptions = {
    mode: "multiRow",
  };

  leftColumns: ColDef[] = [
    {
      rowDrag: true,
      maxWidth: 50,
      suppressHeaderMenuButton: true,
      suppressHeaderFilterButton: true,
      rowDragText: (params, dragItemCount) => {
        if (dragItemCount > 1) {
          return dragItemCount + " athletes";
        }
        return params.rowNode!.data.athlete;
      },
    },
    { field: "athlete" },
    { field: "sport" },
  ];

  rightColumns: ColDef[] = [
    {
      rowDrag: true,
      maxWidth: 50,
      suppressHeaderMenuButton: true,
      suppressHeaderFilterButton: true,
      rowDragText: (params, dragItemCount) => {
        if (dragItemCount > 1) {
          return dragItemCount + " athletes";
        }
        return params.rowNode!.data.athlete;
      },
    },
    { field: "athlete" },
    { field: "sport" },
    {
      suppressHeaderMenuButton: true,
      suppressHeaderFilterButton: true,
      maxWidth: 50,
      cellRenderer: SportRenderer,
    },
  ];

  @ViewChild("eLeftGrid") eLeftGrid: any;
  @ViewChild("eRightGrid") eRightGrid: any;
  @ViewChild("eMoveRadio") eMoveRadio: any;
  @ViewChild("eDeselectRadio") eDeselectRadio: any;

  constructor(private http: HttpClient) {
    this.http
      .get("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => {
        const athletes: any[] = [];
        let i = 0;
        const dataArray = data as any[];

        while (athletes.length < 20 && i < dataArray.length) {
          var pos = i++;
          if (athletes.some((rec) => rec.athlete === dataArray[pos].athlete)) {
            continue;
          }
          athletes.push(dataArray[pos]);
        }
        this.rawData = athletes;
        this.loadGrids();
      });
  }

  loadGrids = () => {
    this.leftRowData = [...this.rawData];
    this.rightRowData = [];
  };

  reset = () => {
    this.eMoveRadio.nativeElement.checked = true;

    this.loadGrids();
  };

  getRowId = (params: GetRowIdParams) => params.data.athlete;

  onGridReady(params: GridReadyEvent, side: number) {
    if (side === 0) {
      this.leftApi = params.api;
    }

    if (side === 1) {
      this.rightApi = params.api;
      this.addGridDropZone();
    }
  }

  addGridDropZone() {
    const dropZoneParams = this.rightApi.getRowDropZoneParams({
      onDragStop: (params) => {
        const deselectCheck = this.eDeselectRadio.nativeElement.checked;
        const moveCheck = this.eMoveRadio.nativeElement.checked;
        const nodes = params.nodes;

        if (moveCheck) {
          this.leftApi.applyTransaction({
            remove: nodes.map(function (node) {
              return node.data;
            }),
          });
        } else if (deselectCheck) {
          this.leftApi.setNodesSelected({ nodes, newValue: false });
        }
      },
    });

    this.leftApi.addRowDropZone(dropZoneParams!);
  }
}
```

[Live example: Multiple Records with Drop Position](https://www.ag-grid.com/archive/36.2.0/examples/row-dragging-to-grid/two-grids-with-multiple-records/angular/)
